package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * It is required when protoType is PPPoE
 */
@ApiModel(description = "It is required when protoType is PPPoE")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class Ipv6PppoeOpenApiVo   {
  @JsonProperty("pppShare")
  private Boolean pppShare;

  @JsonProperty("userName")
  private String userName;

  @JsonProperty("password")
  private String password;

  @JsonProperty("getIpv6Type")
  private Integer getIpv6Type;

  @JsonProperty("prefixEnable")
  private Boolean prefixEnable;

  @JsonProperty("prefixSize")
  private Integer prefixSize;

  @JsonProperty("specificIp")
  private String specificIp;

  @JsonProperty("dnsType")
  private Integer dnsType;

  @JsonProperty("primaryDns")
  private String primaryDns;

  @JsonProperty("secondaryDns")
  private String secondaryDns;

  public Ipv6PppoeOpenApiVo pppShare(Boolean pppShare) {
    this.pppShare = pppShare;
    return this;
  }

  /**
   * Share the same PPPoE session with IPv4
   * @return pppShare
  */
  @ApiModelProperty(required = true, value = "Share the same PPPoE session with IPv4")
  @NotNull


  public Boolean getPppShare() {
    return pppShare;
  }

  public void setPppShare(Boolean pppShare) {
    this.pppShare = pppShare;
  }

  public Ipv6PppoeOpenApiVo userName(String userName) {
    this.userName = userName;
    return this;
  }

  /**
   * Get userName
   * @return userName
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull


  public String getUserName() {
    return userName;
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  public Ipv6PppoeOpenApiVo password(String password) {
    this.password = password;
    return this;
  }

  /**
   * Get password
   * @return password
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull


  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  public Ipv6PppoeOpenApiVo getIpv6Type(Integer getIpv6Type) {
    this.getIpv6Type = getIpv6Type;
    return this;
  }

  /**
   * It should be a value as follows: 0: SLAAC, 1: DHCPv6, 2: specified, 3: auto, 4:non_address, which ranges from 48 ~ 64.
   * @return getIpv6Type
  */
  @ApiModelProperty(required = true, value = "It should be a value as follows: 0: SLAAC, 1: DHCPv6, 2: specified, 3: auto, 4:non_address, which ranges from 48 ~ 64.")
  @NotNull


  public Integer getGetIpv6Type() {
    return getIpv6Type;
  }

  public void setGetIpv6Type(Integer getIpv6Type) {
    this.getIpv6Type = getIpv6Type;
  }

  public Ipv6PppoeOpenApiVo prefixEnable(Boolean prefixEnable) {
    this.prefixEnable = prefixEnable;
    return this;
  }

  /**
   * Get prefixEnable
   * @return prefixEnable
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull


  public Boolean getPrefixEnable() {
    return prefixEnable;
  }

  public void setPrefixEnable(Boolean prefixEnable) {
    this.prefixEnable = prefixEnable;
  }

  public Ipv6PppoeOpenApiVo prefixSize(Integer prefixSize) {
    this.prefixSize = prefixSize;
    return this;
  }

  /**
   * It is required when [prefixEnable] is true.
   * @return prefixSize
  */
  @ApiModelProperty(value = "It is required when [prefixEnable] is true.")


  public Integer getPrefixSize() {
    return prefixSize;
  }

  public void setPrefixSize(Integer prefixSize) {
    this.prefixSize = prefixSize;
  }

  public Ipv6PppoeOpenApiVo specificIp(String specificIp) {
    this.specificIp = specificIp;
    return this;
  }

  /**
   * It is required when [getIpv6Type] is 2.
   * @return specificIp
  */
  @ApiModelProperty(value = "It is required when [getIpv6Type] is 2.")


  public String getSpecificIp() {
    return specificIp;
  }

  public void setSpecificIp(String specificIp) {
    this.specificIp = specificIp;
  }

  public Ipv6PppoeOpenApiVo dnsType(Integer dnsType) {
    this.dnsType = dnsType;
    return this;
  }

  /**
   * DNS Address Type should be a value as follows: 0: dynamic, 1: static.
   * @return dnsType
  */
  @ApiModelProperty(required = true, value = "DNS Address Type should be a value as follows: 0: dynamic, 1: static.")
  @NotNull


  public Integer getDnsType() {
    return dnsType;
  }

  public void setDnsType(Integer dnsType) {
    this.dnsType = dnsType;
  }

  public Ipv6PppoeOpenApiVo primaryDns(String primaryDns) {
    this.primaryDns = primaryDns;
    return this;
  }

  /**
   * It is required when [dnsType] is 1.
   * @return primaryDns
  */
  @ApiModelProperty(value = "It is required when [dnsType] is 1.")


  public String getPrimaryDns() {
    return primaryDns;
  }

  public void setPrimaryDns(String primaryDns) {
    this.primaryDns = primaryDns;
  }

  public Ipv6PppoeOpenApiVo secondaryDns(String secondaryDns) {
    this.secondaryDns = secondaryDns;
    return this;
  }

  /**
   * It takes effect when [dnsType] is 1.
   * @return secondaryDns
  */
  @ApiModelProperty(value = "It takes effect when [dnsType] is 1.")


  public String getSecondaryDns() {
    return secondaryDns;
  }

  public void setSecondaryDns(String secondaryDns) {
    this.secondaryDns = secondaryDns;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Ipv6PppoeOpenApiVo ipv6PppoeOpenApiVo = (Ipv6PppoeOpenApiVo) o;
    return Objects.equals(this.pppShare, ipv6PppoeOpenApiVo.pppShare) &&
        Objects.equals(this.userName, ipv6PppoeOpenApiVo.userName) &&
        Objects.equals(this.password, ipv6PppoeOpenApiVo.password) &&
        Objects.equals(this.getIpv6Type, ipv6PppoeOpenApiVo.getIpv6Type) &&
        Objects.equals(this.prefixEnable, ipv6PppoeOpenApiVo.prefixEnable) &&
        Objects.equals(this.prefixSize, ipv6PppoeOpenApiVo.prefixSize) &&
        Objects.equals(this.specificIp, ipv6PppoeOpenApiVo.specificIp) &&
        Objects.equals(this.dnsType, ipv6PppoeOpenApiVo.dnsType) &&
        Objects.equals(this.primaryDns, ipv6PppoeOpenApiVo.primaryDns) &&
        Objects.equals(this.secondaryDns, ipv6PppoeOpenApiVo.secondaryDns);
  }

  @Override
  public int hashCode() {
    return Objects.hash(pppShare, userName, password, getIpv6Type, prefixEnable, prefixSize, specificIp, dnsType, primaryDns, secondaryDns);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Ipv6PppoeOpenApiVo {\n");
    
    sb.append("    pppShare: ").append(toIndentedString(pppShare)).append("\n");
    sb.append("    userName: ").append(toIndentedString(userName)).append("\n");
    sb.append("    password: ").append(toIndentedString(password)).append("\n");
    sb.append("    getIpv6Type: ").append(toIndentedString(getIpv6Type)).append("\n");
    sb.append("    prefixEnable: ").append(toIndentedString(prefixEnable)).append("\n");
    sb.append("    prefixSize: ").append(toIndentedString(prefixSize)).append("\n");
    sb.append("    specificIp: ").append(toIndentedString(specificIp)).append("\n");
    sb.append("    dnsType: ").append(toIndentedString(dnsType)).append("\n");
    sb.append("    primaryDns: ").append(toIndentedString(primaryDns)).append("\n");
    sb.append("    secondaryDns: ").append(toIndentedString(secondaryDns)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

